#!/bin/sh

type=`cat /sys/kernel/secure/type`
subtype=`cat /sys/kernel/secure/subtype`
hciattachpid=`pidof hciattach-murata`

bt_murata_rts_assert()
{
	if [ "$type" -eq 1 ] && [ "$subtype" -eq 4 ] && [[ ! -z "$hciattachpid" ]]
        then
		kill -SIGUSR1 $hciattachpid
	fi

}

bt_murata_rts_de_assert()
{
	if [ "$type" -eq 1 ] && [ "$subtype" -eq 4 ] && [[ ! -z "$hciattachpid" ]]
        then
		kill -SIGUSR2 $hciattachpid
	fi
}


lte_radio_off()
{
   if [ -d /sys/class/pmic ] && [ -e /dev/ttyLTE0 ]; then
       touch /tmp/waitnetworkmanager
       if [ -w /sys/class/lte_radio/wu_out ]; then
           echo 0 >/sys/class/lte_radio/wu_out && echo 0 >/sys/class/lte_radio/wu_in && inotifywait -e delete -t 10 /dev/ttyLTE0 2> /dev/null
       fi
       if [ -e /dev/ttyLTE0 ]; then
         #  echo "lte_radio_off: 2" >> /var/log/messages
           test -e /sys/class/lte_radio/wu_out; logger -p warning "File /dev/ttyACM0 is still present($?). Forcing LTE power off via rad_on switch."
           echo 1 > /sys/class/lte_radio/rad_on && sleep 3 && echo 0 > /sys/class/lte_radio/rad_on && inotifywait -e delete -t 5 /dev/ttyLTE0 2> /dev/null
       fi
       # XXX: wait for network-manager
       inotifywait -e delete -t 5 /tmp/waitnetworkmanager 2> /dev/null
   fi
}

lte_radio_on()
{
  if [ -w /sys/class/lte_radio/wu_out ]; then
      echo 1 >/sys/class/lte_radio/wu_out
  fi
}

lte_radio_off
bt_murata_rts_de_assert
echo -n standby > /sys/power/state
bt_murata_rts_assert
lte_radio_on
